package com.cslab.HomeApp;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.TextView;

public class HomeApp_Setting extends Activity implements OnClickListener{

	public static final String MYPREFS = "mySharedPreferences";
	private String ip;
	private int port;
	private TextView IP_TEXT, PORT_TEXT;
	static final private int Failed_Diglog_1 = 1;
	static final private int Failed_Diglog_2 = 2;
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
	    super.onCreate(savedInstanceState);
	    setContentView(R.layout.homeapp_set);
	    
	    // Button Event Listener 
	    View Configure_Btn = this.findViewById(R.id.Configure);
	    Configure_Btn.setOnClickListener(this);
	    View Cancel_Btn = this.findViewById(R.id.Set_Cancel);
	    Cancel_Btn.setOnClickListener(this);
	    
	    // EditView Էµ   
	    IP_TEXT = (TextView)this.findViewById(R.id.IP_TEXT);
	    PORT_TEXT = (TextView)this.findViewById(R.id.PORT_TEXT);
	}
	
	// Button Event
	@Override
	public void onClick(View v) {
		switch (v.getId()) {
			case R.id.Configure:
				ip = IP_TEXT.getText().toString();
				// ip   
				if(ip.compareTo("") == 0){
					showDialog(Failed_Diglog_1);
					break;
				}
				// port   
				try{
					port = Integer.parseInt(PORT_TEXT.getText().toString());
				}
				catch (Exception e){
					showDialog(Failed_Diglog_2);
					break;
				}
				savePreference();
				finish();
				break;
			case R.id.Set_Cancel:
				finish();
				break;
		}
	}
	
	// ȯ  
	protected void savePreference() {
		int mode = Activity.MODE_PRIVATE;
		SharedPreferences mySharedPreferences = getSharedPreferences(MYPREFS, mode);
		SharedPreferences.Editor editor = mySharedPreferences.edit();
		
		editor.putString("ip", ip);
		editor.putInt("port", port);
		editor.commit();
	}
	
	// Error Dialog
	@Override
	public Dialog onCreateDialog(int id){
		String button1_String = "Ȯ";
		switch(id) {
			case (Failed_Diglog_1) :
				AlertDialog.Builder Dialog_1 = new AlertDialog.Builder(this);
				Dialog_1.setTitle("");
				Dialog_1.setMessage("IP Էϼ");
				Dialog_1.setPositiveButton(button1_String, null);
				return Dialog_1.create();
			case (Failed_Diglog_2) :
				AlertDialog.Builder Dialog_2 = new AlertDialog.Builder(this);
				Dialog_2.setTitle("");
				Dialog_2.setMessage("PORT Էϼ");
				Dialog_2.setPositiveButton(button1_String, null);
				return Dialog_2.create();
		}
		return null;
	}
}
