/////////////////////////////////////////////////////////////////////////////////////
// ø  Լ 
/////////////////////////////////////////////////////////////////////////////////////

//  
#include "Common.h"
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/signal.h>
#include <sys/ioctl.h>
#include <sys/poll.h>
#include <termios.h>

//  ¸   termios ü
struct termios sOldTIO;

// ø 
int open_serial(char *dev_name, int baud, int vtime, int vmin)
{
	int fd;
	struct termios newtio;

	fd = open(dev_name, O_RDWR | O_NOCTTY);
	if ( fd < 0 )
	{
		printf("Device OPEN FAIL %s\n", dev_name);
		return -1;
	}

	tcgetattr(fd, &sOldTIO);
	memset(&newtio, 0, sizeof(newtio));

	// termios ü 

	// 8Ʈ, б Ȱȭ
	newtio.c_cflag = CS8 | CLOCAL | CREAD;

	// Ʈ 
	switch(baud)
	{
		case 115200 : newtio.c_cflag |= B115200; break;
		case 57600 : newtio.c_cflag |= B57600; break;
		case 38400 : newtio.c_cflag |= B38400; break;
		case 9600 : newtio.c_cflag |= B9600; break;
		case 19200 : newtio.c_cflag |= B19200; break;
		case 4800 : newtio.c_cflag |= B4800; break;
		case 2400 : newtio.c_cflag |= B2400; break;
		default	: newtio.c_cflag |= B115200; break;
	}

	// иƼ  , vtime, vmin 
	newtio.c_iflag = IGNPAR | ICRNL;
	newtio.c_oflag = 0;
	newtio.c_lflag = 0;
	newtio.c_cc[VTIME] = vtime;
	newtio.c_cc[VMIN] = vmin;

	//   ø Ʈ 
	tcflush (fd, TCIFLUSH);
	tcsetattr(fd, TCSANOW, &newtio);

	return fd;
}

// ø ݱ
void close_serial(int nSerialFD)
{
	//    ϰ ø  ݱ
	tcflush(nSerialFD, TCIFLUSH);
	tcsetattr(nSerialFD, TCSANOW, &sOldTIO);
	close(nSerialFD);
}